=== gemrb/plugins/2DAImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN(2DAImporter 2DAImporter.cpp 2DAImporter.h )
