=== gemrb/plugins/BMPWriter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (BMPWriter BMPWriter.cpp)
