=== gemrb/plugins/CHUImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (CHUImporter CHUImporter.cpp)
