=== gemrb/plugins/CREImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (CREImporter CREImporter.cpp)
