=== gemrb/plugins/GUIScript/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})
ADD_GEMRB_PLUGIN (GUIScript GUIScript.cpp PythonErrors.cpp PythonConversions.cpp)
IF(MINGW AND CMAKE_SIZEOF_VOID_P EQUAL 8)
	ADD_DEFINITIONS(-DMS_WIN64)
ENDIF()
# remove this once we move to python3
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing")
TARGET_LINK_LIBRARIES(GUIScript ${PYTHON_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${CMAKE_DL_LIBS})
