=== gemrb/plugins/INIImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (INIImporter INIImporter.cpp)
