=== gemrb/plugins/MUSImporter/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (MUSImporter MUSImporter.cpp)
