=== debian/changelog ===
gemrb (0.9.0+dfsg-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 19:16:56 +0000

gemrb (0.9.0+dfsg-1) unstable; urgency=medium

  [ Beren Minor ]
  * New upstream version 0.9.0
  * Refresh patches line numbers.
  * Update sample configuration files.
  * Update python dependency to python3.
  * Remove stack protector force disable flag.
  * Use preferred SDL2 backend instead of SDL1.2.
  * Strip out demo assets with unclear license and copyrights.

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Repository, Repository-
    Browse.

  [ Stephen Kitt ]
  * Update debian/watch.
  * Remove obsolete entries from debian/copyright.
  * Remove debian/source/include-binaries, it isn’t needed.
  * Switch to debhelper compatibility level 13.
  * Standards-Version 4.6.0, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 02 Oct 2021 17:19:39 +0200

gemrb (0.8.6-1) unstable; urgency=medium

  * New upstream version 0.8.6
  * Update sample gemrb.cfg with upstream changes.
  * Add list of not-installed files.
  * Increase debhelper compat to 12.
  * Increase Standards-Version to 4.4.1.
  * Add Rules-Requires-Root: no control field.
  * Update Vcs-Git and Vcs-Browser URLs.
  * Update spelling fixes patch.
  * Refresh patches line numbers.
  * Remove --with python2 debhelper option.
  * Remove lintian overrides.
  * Add lintian overrides for gemrb-data READMEs.
  * Update copyright dates and URLs.

 -- Beren Minor <beren.minor+debian@gmail.com>  Sun, 22 Dec 2019 16:00:15 +0100
