## gemrb 0.9.2%2Bdfsg

=== gemrb/plugins/PSTOpcodes/CMakeLists.txt ===
ADD_GEMRB_PLUGIN (PSTOpcodes PSTOpcodes.cpp)
