=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,dversionmangle=auto,repacksuffix=+dfsg" \
    https://github.com/gemrb/gemrb/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
